Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 14777)
@@ -1,7 +1,10 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
+  [Serializable]
   public abstract class DoTimesExpression : LoopExpression {
     protected DoTimesExpression() { }
@@ -12,5 +15,5 @@
 
     protected override LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
-      return new LoopState(
+      return LoopState.Create(interpreter.PoolContainer.LoopStatePool,
         body: sourceStack.Pop(),
         currentIndex: 1,
@@ -20,8 +23,8 @@
 
     protected override void PushIteration(IPushInterpreter interpreter) {
-      var newState = new LoopState(State.Body, State.CurrentIndex + this.State.Incrementor, State.DestinationIndex, State.Incrementor);
-      var nextLoopExpression = Clone(newState);
+      var newState = LoopState.Create(interpreter.PoolContainer.LoopStatePool, State.Body, State.CurrentIndex + this.State.Incrementor, State.DestinationIndex, State.Incrementor);
+      var nextLoopExpression = Clone(newState, interpreter);
 
-      interpreter.ExecStack.Push(nextLoopExpression, this.State.Body);
+      interpreter.ExecStack.Push(nextLoopExpression, State.Body);
     }
 
@@ -37,5 +40,6 @@
   ///     in the call to CODE.DO*RANGE.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.DO*TIMES")]
+  [Serializable]
+  [PushExpression(StackTypes.Code, "CODE.DO*TIMES", StackTypes.Integer)]
   public class CodeDoTimesExpression : DoTimesExpression {
     public CodeDoTimesExpression() { }
@@ -46,6 +50,9 @@
     }
 
-    protected override LoopExpression Clone(LoopState state) {
-      return new CodeDoTimesExpression(state);
+    protected override LoopExpression Clone(LoopState state, IPushInterpreter interpreter) {
+      var expression = interpreter.PoolContainer.GetStatefulExpression<CodeDoTimesExpression>();
+      expression.State = state;
+
+      return expression;
     }
   }
@@ -60,5 +67,6 @@
   ///     pushed by EXEC.DO*RANGE, prior to the execution of the loop body.
   /// </summary>
-  [PushExpression(StackType.Exec, "EXEC.DO*TIMES")]
+  [Serializable]
+  [PushExpression(StackTypes.Exec, "EXEC.DO*TIMES", StackTypes.Integer)]
   public class ExecDoTimesExpression : DoTimesExpression {
     public ExecDoTimesExpression() { }
@@ -69,6 +77,9 @@
     }
 
-    protected override LoopExpression Clone(LoopState state) {
-      return new ExecDoTimesExpression(state);
+    protected override LoopExpression Clone(LoopState state, IPushInterpreter interpreter) {
+      var expression = interpreter.PoolContainer.GetStatefulExpression<ExecDoTimesExpression>();
+      expression.State = state;
+
+      return expression;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 14777)
@@ -28,5 +28,5 @@
   }
 
-  [PushExpression(StackType.Integer, "INTEGER.DUP")]
+  [PushExpression(StackTypes.Integer, "INTEGER.DUP")]
   public class IntegerDuplicateExpression : DuplicateExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -35,5 +35,5 @@
   }
 
-  [PushExpression(StackType.Float, "FLOAT.DUP")]
+  [PushExpression(StackTypes.Float, "FLOAT.DUP")]
   public class FloatDuplicateExpression : DuplicateExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -42,5 +42,5 @@
   }
 
-  [PushExpression(StackType.Boolean, "BOOLEAN.DUP")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.DUP")]
   public class BooleanDuplicateExpression : DuplicateExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -49,5 +49,5 @@
   }
 
-  [PushExpression(StackType.Name, "NAME.DUP")]
+  [PushExpression(StackTypes.Name, "NAME.DUP")]
   public class NameDuplicateExpression : DuplicateExpression<string> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -56,5 +56,5 @@
   }
 
-  [PushExpression(StackType.Exec, "EXEC.DUP")]
+  [PushExpression(StackTypes.Exec, "EXEC.DUP")]
   public class ExecDuplicateExpression : DuplicateExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -63,5 +63,5 @@
   }
 
-  [PushExpression(StackType.Code, "CODE.DUP")]
+  [PushExpression(StackTypes.Code, "CODE.DUP")]
   public class CodeDuplicateExpression : DuplicateExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpresssions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpresssions.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpresssions.cs	(revision 14777)
@@ -0,0 +1,66 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+
+  using Stack;
+
+  /// <summary>
+  /// Tells whether that stack is empty.
+  /// </summary>
+  public abstract class EmptyExpresssions<T> : StatelessExpression {
+    public bool Eval(IStack<T> stack, IStack<bool> booleanStack) {
+      booleanStack.Push(stack.IsEmpty);
+
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Exec, "EXEC.EMPTY", StackTypes.Boolean)]
+  public class ExecEmptyExpression : EmptyExpresssions<Expression> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Code, "CODE.EMPTY", StackTypes.Boolean)]
+  public class CodeEmptyExpression : EmptyExpresssions<Expression> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Integer, "INTEGER.EMPTY", StackTypes.Boolean)]
+  public class IntegerEmptyExpression : EmptyExpresssions<long> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Float, "FLOAT.EMPTY", StackTypes.Boolean)]
+  public class FloatEmptyExpression : EmptyExpresssions<double> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.EMPTY", StackTypes.Boolean)]
+  public class BooleanEmptyExpression : EmptyExpresssions<bool> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Char, "CHAR.EMPTY", StackTypes.Boolean)]
+  public class CharEmptyExpression : EmptyExpresssions<char> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CharStack, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.String, "STRING.EMPTY", StackTypes.Boolean)]
+  public class StringEmptyExpression : EmptyExpresssions<string> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.StringStack, interpreter.BooleanStack);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14777)
@@ -20,5 +20,5 @@
   }
 
-  [PushExpression(StackType.Integer, "INTEGER.=")]
+  [PushExpression(StackTypes.Integer, "INTEGER.=", StackTypes.Boolean)]
   public class IntegerEqualsExpression : EqualsExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -27,5 +27,5 @@
   }
 
-  [PushExpression(StackType.Float, "FLOAT.=")]
+  [PushExpression(StackTypes.Float, "FLOAT.=", StackTypes.Boolean)]
   public class FloatEqualsExpression : EqualsExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -34,5 +34,5 @@
   }
 
-  [PushExpression(StackType.Boolean, "BOOLEAN.=")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.=", StackTypes.Boolean)]
   public class BooleanEqualsExpression : EqualsExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -41,5 +41,5 @@
   }
 
-  [PushExpression(StackType.Name, "NAME.=")]
+  [PushExpression(StackTypes.Name, "NAME.=", StackTypes.Boolean)]
   public class NameEqualsExpression : EqualsExpression<string> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -48,5 +48,5 @@
   }
 
-  [PushExpression(StackType.Exec, "EXEC.=")]
+  [PushExpression(StackTypes.Exec, "EXEC.=", StackTypes.Boolean)]
   public class ExecEqualsExpression : EqualsExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -55,5 +55,5 @@
   }
 
-  [PushExpression(StackType.Code, "CODE.=")]
+  [PushExpression(StackTypes.Code, "CODE.=", StackTypes.Boolean)]
   public class CodeEqualsExpression : EqualsExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -61,3 +61,17 @@
     }
   }
+
+  [PushExpression(StackTypes.Char, "CHAR.=", StackTypes.Boolean)]
+  public class CharEqualsExpression : EqualsExpression<char> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CharStack, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.String, "STRING.=", StackTypes.Boolean)]
+  public class StringEqualsExpression : EqualsExpression<string> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.StringStack, interpreter.BooleanStack);
+    }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14777)
@@ -12,5 +12,5 @@
   /// one item on the BOOLEAN stack.
   /// </summary>
-  [PushExpression(StackType.Exec, "EXEC.IF")]
+  [PushExpression(StackTypes.Exec, "EXEC.IF", StackTypes.Boolean)]
   public class ExecIfExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -31,5 +31,5 @@
   ///     "( EXEC.Y <TopItem> )".
   /// </summary>
-  [PushExpression(StackType.Exec, "EXEC.Y")]
+  [PushExpression(StackTypes.Exec, "EXEC.Y")]
   public class ExecYExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -40,6 +40,15 @@
 
       var top = interpreter.ExecStack.Top;
+
+      if (top is PushProgram && ((PushProgram)top).Depth == interpreter.Configuration.MaxDepth)
+        return false;
+
       var execYExpression = ExpressionTable.GetStatelessExpression<ExecYExpression>();
-      var result = PushProgram.Create(interpreter.PushProgramPool, top, execYExpression);
+      var expressions = interpreter.PoolContainer.ExpressionListPool.Get();
+
+      expressions.Add(top);
+      expressions.Add(execYExpression);
+
+      var result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
 
       interpreter.ExecStack.SetTop(result);
@@ -53,5 +62,5 @@
   ///     Removes the second item on the EXEC stack.
   /// </summary>
-  [PushExpression(StackType.Exec, "EXEC.K")]
+  [PushExpression(StackTypes.Exec, "EXEC.K")]
   public class ExecKExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -70,8 +79,13 @@
   ///     another instance of C, followed by another instance of A.
   /// </summary>
-  [PushExpression(StackType.Exec, "EXEC.S")]
+  [PushExpression(StackTypes.Exec, "EXEC.S")]
   public class ExecSExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.ExecStack.Count < 3) return false;
+
+      // check max depth
+      if ((interpreter.ExecStack.Top is PushProgram && ((PushProgram)interpreter.ExecStack.Top).Depth == interpreter.Configuration.MaxDepth) ||
+          (interpreter.ExecStack.ReverseElementAt(1) is PushProgram && ((PushProgram)interpreter.ExecStack.ReverseElementAt(1)).Depth == interpreter.Configuration.MaxDepth))
+        return false;
 
       var expression = interpreter.ExecStack.Pop(2);
@@ -80,5 +94,9 @@
       var c = interpreter.ExecStack.Top;
 
-      var newTop = PushProgram.Create(interpreter.PushProgramPool, c, b);
+      var expressions = interpreter.PoolContainer.ExpressionListPool.Get();
+      expressions.Add(c);
+      expressions.Add(b);
+
+      var newTop = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
 
       interpreter.ExecStack.SetTop(newTop);
@@ -88,3 +106,64 @@
     }
   }
+
+  /// <summary>
+  ///     Does nothing.
+  /// </summary>
+  [PushExpression(StackTypes.Exec, "EXEC.NOOP")]
+  public class ExecNoopExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return false;
+    }
+  }
+
+  [PushExpression(StackTypes.Exec, "EXEC.WHILE", StackTypes.Boolean)]
+  public class ExecWhileExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.ExecStack.IsEmpty)
+        return false;
+
+      if (interpreter.BooleanStack.IsEmpty) {
+        interpreter.ExecStack.Pop();
+        return true;
+      }
+
+      var booleanTop = interpreter.BooleanStack.Pop();
+
+      if (!booleanTop) {
+        interpreter.ExecStack.Pop();
+        return true;
+      }
+
+      interpreter.ExecStack.Push(this, interpreter.ExecStack.Top);
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Exec, "EXEC.DO*WHILE")]
+  public class ExecDoWhileExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.ExecStack.IsEmpty)
+        return false;
+
+      interpreter.ExecStack.Push(this, interpreter.ExecStack.Top);
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Exec, "EXEC.WHEN", StackTypes.Boolean)]
+  public class ExecWhenExpression : StatelessExpression {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.ExecStack.IsEmpty ||
+          interpreter.BooleanStack.IsEmpty)
+        return false;
+
+      var when = interpreter.BooleanStack.Pop();
+
+      if (!when) {
+        interpreter.ExecStack.Pop();
+      }
+
+      return true;
+    }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14777)
@@ -4,9 +4,10 @@
 
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
 
   using Interpreter;
 
   [Serializable]
-  public abstract class Expression {
+  public abstract class Expression : IPooledObject {
     public bool IsProgram { get { return this.GetType() == typeof(PushProgram); } }
 
@@ -30,4 +31,6 @@
       return this.StringRepresentation;
     }
+
+    void IPooledObject.Reset() { }
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14777)
@@ -10,18 +10,25 @@
   public static class ExpressionTable {
     public static readonly IDictionary<string, Expression> StatelessExpressionTable;
-    public static readonly IDictionary<string, Func<Expression>> StatefullExpressionFactory;
-    public static readonly IDictionary<StackType, IList<string>> StackTypeToNamesTable = new Dictionary<StackType, IList<string>>();
+    public static readonly IDictionary<string, Func<Expression>> StatefulExpressionFactory;
+    public static readonly IDictionary<StackTypes, IList<string>> StackTypeToNamesTable = new Dictionary<StackTypes, IList<string>>();
     public static readonly IDictionary<int, string> IndexToNameTable = new Dictionary<int, string>();
     public static readonly IDictionary<Type, string> TypeToNameTable = new Dictionary<Type, string>();
+    public static readonly IDictionary<StackTypes, IList<string>> StackDependencyToNamesTable = new Dictionary<StackTypes, IList<string>>();
     public static readonly string[] ExpressionNames;
 
+    public static readonly Type[] StatelessExpressionTypes;
+    public static readonly Type[] StatefulExpressionTypes;
+
     public static readonly int Count;
 
     static ExpressionTable() {
+      StatelessExpressionTypes = GetExpressionTypes(typeof(StatelessExpression)).ToArray();
+      StatefulExpressionTypes = GetExpressionTypes(typeof(StatefulExpression<>)).ToArray();
+
       StatelessExpressionTable = GetStatelessExpressionTable();
-      StatefullExpressionFactory = GetStatefullExpressionFactory();
-      ExpressionNames = StatelessExpressionTable.Keys.Concat(StatefullExpressionFactory.Keys).ToArray();
-
-      Count = StatelessExpressionTable.Count + StatefullExpressionFactory.Count;
+      StatefulExpressionFactory = GetStatefulExpressionFactory();
+      ExpressionNames = StatelessExpressionTable.Keys.Concat(StatefulExpressionFactory.Keys).ToArray();
+
+      Count = StatelessExpressionTable.Count + StatefulExpressionFactory.Count;
     }
 
@@ -38,5 +45,5 @@
       get
       {
-        return StatefullExpressionFactory.Count;
+        return StatefulExpressionFactory.Count;
       }
     }
@@ -44,7 +51,6 @@
     private static Dictionary<string, Expression> GetStatelessExpressionTable() {
       var dictionary = new Dictionary<string, Expression>();
-      var expressionTypes = GetExpressionTypes(typeof(StatelessExpression));
-
-      foreach (var type in expressionTypes) {
+
+      foreach (var type in StatelessExpressionTypes) {
         var expression = Activator.CreateInstance(type) as Expression;
         var attribute = (PushExpressionAttribute)Attribute.GetCustomAttribute(type, typeof(PushExpressionAttribute));
@@ -54,9 +60,16 @@
         TypeToNameTable.Add(type, attribute.ExpressionName);
 
-        if (!StackTypeToNamesTable.ContainsKey(attribute.StackType)) {
-          StackTypeToNamesTable.Add(attribute.StackType, new List<string>());
-        }
-
-        StackTypeToNamesTable[attribute.StackType].Add(attribute.ExpressionName);
+        if (!StackTypeToNamesTable.ContainsKey(attribute.StackTypes)) {
+          StackTypeToNamesTable.Add(attribute.StackTypes, new List<string>());
+        }
+
+        StackTypeToNamesTable[attribute.StackTypes].Add(attribute.ExpressionName);
+
+        var dependencies = attribute.StackTypes | attribute.AdditionalStackDependencies;
+        if (!StackDependencyToNamesTable.ContainsKey(dependencies)) {
+          StackDependencyToNamesTable.Add(dependencies, new List<string>());
+        }
+
+        StackDependencyToNamesTable[dependencies].Add(attribute.ExpressionName);
       }
 
@@ -64,10 +77,8 @@
     }
 
-    private static Dictionary<string, Func<Expression>> GetStatefullExpressionFactory() {
+    private static Dictionary<string, Func<Expression>> GetStatefulExpressionFactory() {
       var dictionary = new Dictionary<string, Func<Expression>>();
-      var statefullExpressionType = typeof(StatefulExpression<>);
-      var expressionTypes = GetExpressionTypes(statefullExpressionType);
-
-      foreach (var type in expressionTypes) {
+
+      foreach (var type in StatefulExpressionTypes) {
         // Make a NewExpression that calls the ctor
         var newExp = System.Linq.Expressions.Expression.New(type);
@@ -81,9 +92,16 @@
         TypeToNameTable.Add(type, attribute.ExpressionName);
 
-        if (!StackTypeToNamesTable.ContainsKey(attribute.StackType)) {
-          StackTypeToNamesTable.Add(attribute.StackType, new List<string>());
-        }
-
-        StackTypeToNamesTable[attribute.StackType].Add(attribute.ExpressionName);
+        if (!StackTypeToNamesTable.ContainsKey(attribute.StackTypes)) {
+          StackTypeToNamesTable.Add(attribute.StackTypes, new List<string>());
+        }
+
+        StackTypeToNamesTable[attribute.StackTypes].Add(attribute.ExpressionName);
+
+        var dependencies = attribute.StackTypes | attribute.AdditionalStackDependencies;
+        if (!StackDependencyToNamesTable.ContainsKey(dependencies)) {
+          StackDependencyToNamesTable.Add(dependencies, new List<string>());
+        }
+
+        StackDependencyToNamesTable[dependencies].Add(attribute.ExpressionName);
       }
 
@@ -124,4 +142,11 @@
     }
 
+    public static IReadOnlyList<string> GetEnabledExpressionsByStackTypes(StackTypes allowedTypes) {
+      return StackDependencyToNamesTable
+          .Where(entry => (entry.Key & ~allowedTypes) == StackTypes.None)
+          .SelectMany(entry => entry.Value)
+          .ToArray();
+    }
+
     public static PushProgram GetProgram(IManagedPool<PushProgram> pool, int[] index) {
       var expressions = new Expression[index.Length];
@@ -142,5 +167,5 @@
 
       if (!TryGetStatelessExpression(name, out expression) &&
-          !TryGetStatefullExpression(name, out expression))
+          !TryGetStatefulExpression(name, out expression))
         throw new InvalidOperationException(string.Format("Expression with name {0} not found", name));
 
@@ -153,30 +178,34 @@
 
     public static Expression GetStatelessExpression(string name) {
-      Expression expression;
-      if (StatelessExpressionTable.TryGetValue(name, out expression))
-        return expression;
+      if (StatelessExpressionTable.ContainsKey(name))
+        return StatelessExpressionTable[name];
       throw new NotSupportedException("Expression not supported: " + name);
     }
 
     public static bool TryGetStatelessExpression(string name, out Expression expression) {
-      return StatelessExpressionTable.TryGetValue(name, out expression);
-    }
-
-    public static Expression GetStatefullExpression<T>() {
-      return GetStatefullExpression(TypeToNameTable[typeof(T)]);
-    }
-
-    public static Expression GetStatefullExpression(string name) {
+      if (!StatelessExpressionTable.ContainsKey(name)) {
+        expression = null;
+        return false;
+      }
+
+      expression = StatelessExpressionTable[name];
+
+      return true;
+    }
+
+    public static Expression GetStatefulExpression<T>() {
+      return GetStatefulExpression(TypeToNameTable[typeof(T)]);
+    }
+
+    public static Expression GetStatefulExpression(string name) {
       Func<Expression> creator;
-      if (StatefullExpressionFactory.TryGetValue(name, out creator))
+      if (StatefulExpressionFactory.TryGetValue(name, out creator))
         return creator();
       throw new NotSupportedException("Expression not supported: " + name);
     }
 
-    public static bool TryGetStatefullExpression(string name, out Expression expression) {
-      Func<Expression> creator;
-
-      if (StatefullExpressionFactory.TryGetValue(name, out creator)) {
-        expression = creator();
+    public static bool TryGetStatefulExpression(string name, out Expression expression) {
+      if (StatefulExpressionFactory.ContainsKey(name)) {
+        expression = StatefulExpressionFactory[name]();
         return true;
       }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 14777)
@@ -9,5 +9,5 @@
   ///     Pushes the sum of the top two items.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.+")]
+  [PushExpression(StackTypes.Float, "FLOAT.+")]
   public class FloatAddExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -19,5 +19,5 @@
   ///     Pushes the difference of the top two items; that is, the second item minus the top item.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.-")]
+  [PushExpression(StackTypes.Float, "FLOAT.-")]
   public class FloatSubtractExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -29,5 +29,5 @@
   ///     Pushes the product of the top two items.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.*")]
+  [PushExpression(StackTypes.Float, "FLOAT.*")]
   public class FloatMultiplyExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -40,5 +40,5 @@
   ///     If the top item is zero this acts as a NOOP.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT./")]
+  [PushExpression(StackTypes.Float, "FLOAT./")]
   public class FloatDivideExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -54,5 +54,5 @@
   ///     for example at http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.%")]
+  [PushExpression(StackTypes.Float, "FLOAT.%")]
   public class FloatModuloExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -64,5 +64,5 @@
   ///     Pushes the minimum of the top two items.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.MIN")]
+  [PushExpression(StackTypes.Float, "FLOAT.MIN")]
   public class FloatMinExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -74,5 +74,5 @@
   ///     Pushes the maximum of the top two items.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.MAX")]
+  [PushExpression(StackTypes.Float, "FLOAT.MAX")]
   public class FloatMaxExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -84,5 +84,5 @@
   ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.<")]
+  [PushExpression(StackTypes.Float, "FLOAT.<", StackTypes.Boolean)]
   public class FloatSmallerThanExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -92,7 +92,17 @@
 
   /// <summary>
+  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.<=", StackTypes.Boolean)]
+  public class FloatSmallerThanOrEqualExpression : PushResultExpression<double> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] <= values[1]);
+    }
+  }
+
+  /// <summary>
   ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.>")]
+  [PushExpression(StackTypes.Float, "FLOAT.>", StackTypes.Boolean)]
   public class FloatGreaterThanExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -102,7 +112,17 @@
 
   /// <summary>
+  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than or equal to the top item, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.>=", StackTypes.Boolean)]
+  public class FloatGreaterThanOrEqualExpression : PushResultExpression<double> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] >= values[1]);
+    }
+  }
+
+  /// <summary>
   ///     Pushes the sine of the top item.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.SIN")]
+  [PushExpression(StackTypes.Float, "FLOAT.SIN")]
   public class FloatSineExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -114,5 +134,5 @@
   ///     Pushes the cosine of the top item.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.COS")]
+  [PushExpression(StackTypes.Float, "FLOAT.COS")]
   public class FloatCosineExpression : PushResultExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -124,5 +144,5 @@
   ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.FROMBOOLEAN")]
+  [PushExpression(StackTypes.Float, "FLOAT.FROMBOOLEAN", StackTypes.Boolean)]
   public class FloatFromBooleanExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -141,5 +161,5 @@
   ///     Pushes a floating point version of the top INTEGER.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.FROMINTEGER")]
+  [PushExpression(StackTypes.Float, "FLOAT.FROMINTEGER", StackTypes.Integer)]
   public class FloatFromIntegerExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
